''Clean affine texture.
''relsoft 2003
DECLARE SUB FFIX (Mode%)
DECLARE SUB Rel.LoadBMP (DestSeg%, File$, SwitchPal%)
DECLARE SUB SortIndex (Poly() AS ANY, Min%, Max%)
DECLARE SUB DrawTorusT (Model() AS ANY, Poly() AS ANY)
DECLARE SUB Tritexture (xx1%, yy1%, xx2%, yy2%, xx3%, yy3%, uu1%, vv1%, uu2%, vv2%, uu3%, vv3%, TSEG%, TOFF%)
DECLARE SUB HTLine (xx1%, xx2%, yy%, uu1&, uu2&, vv1&, vv2&, Twidth%, TOFF%)
DECLARE SUB SortPolys (Model() AS ANY, Poly() AS ANY)
DECLARE SUB RotateAndProject (Model() AS ANY, AngleX%, AngleY%, AngleZ%)
DECLARE SUB SetVideoSeg (Segment%)
DECLARE SUB LoadTorus (Rings%, Bands%, RINGRADIUS%, BandRadius%, Model() AS ANY, Poly() AS ANY)
DEFINT A-Z
REM $DYNAMIC

TYPE BMPHeaderType                              'All values are for 320*200*256 bmp
        ID              AS STRING * 2           '"BM"
        Size            AS LONG                 'width*heigth+1078= 65078
        RSV1            AS INTEGER              '0 Reserved
        RSV2            AS INTEGER              '0 Reserved
        offset          AS LONG                 '1078  First Pixel(Scanline order)
        HORZ            AS LONG                 '40
        WID             AS LONG                 '320
        HEI             AS LONG                 '200
        PLANES          AS INTEGER              '1   num of Planes
        BPP             AS INTEGER              '8   Bits per Plane
        COMPRESSION     AS LONG                 '0
        IMAGESIZE       AS LONG                 '64000  Width *Height
        XRES            AS LONG                 '3790  X pels
        YRES            AS LONG                 '3780  Y pels
        CLRUSED         AS LONG                 '0 Colors used
        CLRIMPORT       AS LONG                 '0 Colors Important
        Pal             AS STRING * 1024        'Order=Blue*4, Green*4, Red*4, 0 * 4
END TYPE


TYPE Point3d
        x       AS SINGLE
        y       AS SINGLE
        z       AS SINGLE
        xr      AS SINGLE
        yr      AS SINGLE
        Zr      AS SINGLE
        scrx    AS INTEGER
        scry    AS INTEGER
END TYPE

TYPE PolyType
        p1      AS INTEGER
        p2      AS INTEGER
        p3      AS INTEGER
        Clr     AS INTEGER
        u1      AS INTEGER          'Texture U and V
        v1      AS INTEGER
        u2      AS INTEGER
        v2      AS INTEGER
        u3      AS INTEGER
        v3      AS INTEGER
        zcenter AS INTEGER
        idx     AS INTEGER
        Tnum    AS INTEGER
END TYPE



CONST LENS = 256
CONST XCENTER = 160
CONST YCENTER = 100

CONST TORNUMRINGS = 24          'Number of Rings outside TORUS
CONST TORNUMBANDS = 16          'Number of PIXEL per RING
CONST TORRINGRADIUS = 120       'Radius of the Ring
CONST TORBANDRADIUS = 50        'Radius of the BAND

'Sphere
CONST SRADIUS = 50              'Radius of Sphere
CONST SPSLICES = 11             'Number of Slices
CONST SPBANDS = 20              'number of Pixel per slice

CONST TSIZE% = 64
CONST TSIZEM1% = TSIZE% - 1

CONST PI = 3.14151693#

REDIM SHARED Vpage(32009) AS INTEGER

REDIM SHARED Texture%(((4 + (TSIZE% * TSIZE%)) \ 2) * 4)

DIM SHARED Lcos(359) AS SINGLE
DIM SHARED Lsin(359) AS SINGLE

REDIM SHARED Torus(1) AS Point3d
REDIM SHARED TorusTri(1) AS PolyType

REDIM SHARED Sphere(1) AS Point3d

DIM SHARED ThetaX, ThetaY, ThetaZ
DIM SHARED camz, LastT%

DIM SHARED TextSeg%, Textoff%, ImgSize%


camz = LENS

FOR i = 0 TO 359
    A! = i * PI / 180
    Lcos(i) = COS(A!)
    Lsin(i) = SIN(A!)
NEXT i

CLS
SCREEN 13


'Grey Scale the Palette
 FOR i = 0 TO 255
  OUT &H3C8, i
  OUT &H3C9, i \ 4
  OUT &H3C9, i \ 4
  OUT &H3C9, i \ 4
 NEXT i


path$ = "C:\Qbasic\3dTute\"
path$ = ""
File$ = path$ + "Green.Bmp"
Rel.LoadBMP LAYER, File$, -1
i% = 0
ImgSize% = (4 + TSIZE% * TSIZE%) \ 2
FOR x = 0 TO 1
FOR y = 0 TO 1
    GET (x * TSIZE%, y * TSIZE%)-STEP(TSIZE% - 1, TSIZE% - 1), Texture%(i% * ImgSize%)
    i% = i% + 1
NEXT y
NEXT x



TextSeg% = VARSEG(Texture%(0))
Textoff% = VARPTR(Texture%(0))

ThetaX = 120
ThetaY = 0
ThetaZ = 0

FFIX 0
LoadTorus TORNUMRINGS, TORNUMBANDS, TORRINGRADIUS, TORBANDRADIUS, Torus(), TorusTri()

REDIM Vpage(32009) AS INTEGER        'Clear offscreen buffer
Vpage(6) = 2560                      'Width 320*8
Vpage(7) = 200                       'Height
LAYER = VARSEG(Vpage(0)) + 1         'Buffer Seg(Ask Plasma)
SetVideoSeg LAYER                    'Set Draw to Buffer


T# = TIMER
Frame& = 0

DO
        Frame& = Frame& + 1
        SetVideoSeg LAYER                    'Set Draw to Buffer
        LINE (0, 0)-(319, 199), 0, BF
        ThetaX = (ThetaX + 1) MOD 360
        ThetaY = (ThetaY + 1) MOD 360
        ThetaZ = (ThetaZ + 1) MOD 360
        RotateAndProject Torus(), ThetaX, ThetaY, ThetaZ
        SortPolys Torus(), TorusTri()
        DrawTorusT Torus(), TorusTri()
        SetVideoSeg &HA000
        PUT (0, 0), Vpage(6), PSET

LOOP UNTIL INKEY$ <> ""

DEF SEG

FFIX -1
CLS
SCREEN 0
WIDTH 80
PRINT Frame& / (TIMER - T#)

c$ = INPUT$(1)


END

REM $STATIC
SUB DrawTorusT (Model() AS Point3d, Poly() AS PolyType) STATIC

FOR i = 0 TO UBOUND(Poly) - 1
    j = Poly(i).idx
    x1 = Model(Poly(j).p1).scrx       'Get triangles from "projected"
    x2 = Model(Poly(j).p2).scrx       'X and Y coords since Znormal
    x3 = Model(Poly(j).p3).scrx       'Does not require a Z coord
    y1 = Model(Poly(j).p1).scry       'V1= Point1 connected to V2 then
    y2 = Model(Poly(j).p2).scry       'V2 to V3 and so on...
    y3 = Model(Poly(j).p3).scry
       
    'Use the Znormal,the Ray perpendicular(Orthogonal) to the Screen
    'Defined by the Triangle (X1,Y1,X2,Y2,X3,Y3)
    'if Less(<) 0 then its facing in the opposite direction so
    'don't plot. If =>0 then its facing towards you so Plot.

    Znormal = (x2 - x1) * (y1 - y3) - (y2 - y1) * (x1 - x3)
    IF Znormal >= 0 THEN
       u1 = Poly(j).u1
       v1 = Poly(j).v1
       u2 = Poly(j).u2
       v2 = Poly(j).v2
       u3 = Poly(j).u3
       v3 = Poly(j).v3
       T% = Poly(j).Tnum
       TOFF% = VARPTR(Texture%(T% * ImgSize%))
       Tritexture x1, y1, x2, y2, x3, y3, u1, v1, u2, v2, u3, v3, TextSeg%, TOFF%
    END IF
NEXT i

END SUB

SUB FFIX (Mode%) STATIC
IF Mode% = 0 THEN
    DIM isr(0 TO 5) AS LONG                     'FFix by Dav,Plasma and v1ctor
    isr(0) = &H53EC8B55: isr(1) = &H83025E8B
    isr(2) = &H8E0602EB: isr(3) = &HC7260446
    isr(4) = &H79B9007: isr(5) = &HCF9B5D5B
    DEF SEG = 0
    OldISR1 = PEEK(&HF4)
    OldISR2 = PEEK(&HF5)
    OldISR3 = PEEK(&HF6)
    OldISR4 = PEEK(&HF7)
    POKE &HF4, VARPTR(isr(0)) AND 255
    POKE &HF5, (CLNG(VARPTR(isr(0))) AND &HFF00&) \ 256
    POKE &HF6, VARSEG(isr(0)) AND 255
    POKE &HF7, (CLNG(VARSEG(isr(0))) AND &HFF00&) \ 256

ELSE

DEF SEG = 0
POKE &HF4, OldISR1
POKE &HF5, OldISR2
POKE &HF6, OldISR3
POKE &HF7, OldISR4


END IF

END SUB

SUB HTLine (xx1%, xx2%, yy%, uu1&, uu2&, vv1&, vv2&, Twidth%, TOFF%)


x1% = xx1%
x2% = xx2%
y% = yy%
u1& = uu1&
v1& = vv1&
u2& = uu2&
v2& = vv2&


IF x1% > x2% THEN SWAP x1%, x2%: SWAP u1&, u2&: SWAP v1&, v2&
xdiff% = 1 + x2% - x1%

du& = (u2& - u1&) \ xdiff%
dv& = (v2& - v1&) \ xdiff%

u& = u1&
v& = v1&

Twidthm1% = Twidth% - 1

FOR l% = x1% TO x2%
u% = (u& \ 65536) AND Twidthm1%
v% = (v& \ 65536) AND Twidthm1%
col% = PEEK(TOFF% + (u% + v% * Twidth%))
PSET (l%, y%), col%
u& = u& + du&
v& = v& + dv&
NEXT l%

END SUB

SUB LoadTorus (Rings, Bands, RINGRADIUS, BandRadius, Model() AS Point3d, Poly() AS PolyType)

MaxPoint% = Rings * Bands
REDIM Model((MaxPoint%)) AS Point3d

  A1! = 2 * PI / Rings: A2! = 2 * PI / Bands
  i% = 0
 FOR S2% = 0 TO Bands - 1
  FOR S1% = 0 TO Rings - 1
    x1! = COS(S1% * A1!) * RINGRADIUS
    y1! = SIN(S1% * A1!) * RINGRADIUS
     Model(i%).x = x1! + COS(S1% * A1!) * COS(S2% * A2!) * BandRadius
     Model(i%).y = y1! + SIN(S1% * A1!) * COS(S2% * A2!) * BandRadius
     Model(i%).z = SIN(S2% * A2!) * BandRadius
    i% = i% + 1
  NEXT S1%
 NEXT S2%


  i% = 0
  MaxTri% = 0
  FOR S1% = Bands - 1 TO 0 STEP -1
   FOR S2% = Rings - 1 TO 0 STEP -1
    i% = i% + 1
    MaxTri% = MaxTri% + 1
    i% = i% + 1
    MaxTri% = MaxTri% + 1
   NEXT S2%
  NEXT S1%

  REDIM Poly(MaxTri%) AS PolyType
  TT2% = 0
  i% = 0
  FOR S2% = Rings - 1 TO 0 STEP -1
  FOR S1% = Bands - 1 TO 0 STEP -1
    TorusTri(i%).p1 = S1% * Rings + S2%
    TorusTri(i%).p2 = S1% * Rings + (S2% + 1) MOD Rings
    TorusTri(i%).p3 = (S1% * Rings + S2% + Rings) MOD MaxPoint%
    c% = INT(RND * 255) + 1
    TorusTri(i%).Clr = c%
    TorusTri(i%).u1 = TSIZE%
    TorusTri(i%).v1 = 0
    TorusTri(i%).u2 = 0
    TorusTri(i%).v2 = 0
    TorusTri(i%).u3 = TSIZE%
    TorusTri(i%).v3 = TSIZE%
    TorusTri(i%).Tnum = T% + (TT2% * 2)
    i% = i% + 1
    TorusTri(i%).p1 = S1% * Rings + (S2% + 1) MOD Rings
    TorusTri(i%).p2 = (S1% * Rings + (S2% + 1) MOD Rings + Rings) MOD MaxPoint%
    TorusTri(i%).p3 = (S1% * Rings + S2% + Rings) MOD MaxPoint%
    TorusTri(i%).Clr = c%
    TorusTri(i%).u1 = 0
    TorusTri(i%).v1 = 0
    TorusTri(i%).u2 = 0
    TorusTri(i%).v2 = TSIZE%
    TorusTri(i%).u3 = TSIZE%
    TorusTri(i%).v3 = TSIZE%
    TorusTri(i%).Tnum = T% + (TT2% * 2)
    T% = (T% + 1) AND 1
    i% = i% + 1
   NEXT S1%
   TT2% = ((TT2% + 1) AND 1)
  NEXT S2%

END SUB

SUB Rel.LoadBMP (DestSeg%, File$, SwitchPal%) STATIC
'Loads a BMP to a layer or directly to the screen
'if you want it to be on screen pass &HA000 as DestSeg%
'only supports 256 color BMPs.
DIM BMP AS BMPHeaderType

F% = FREEFILE                   'Get free filenum
OPEN File$ FOR BINARY AS #F%    'Binary read
GET #F%, , BMP                   'Get header

'Our File Pointer points to 55 byte seek 55, first byte
'Pal should be 1024 in length
Pall$ = BMP.Pal
IF SwitchPal% THEN              'if we switch to pal then
        IF LEN(Pall$) = 1024 THEN
                OUT &H3C8, 0              'color zero start
                FOR i% = 1 TO 1024 STEP 4
                        B% = ASC(MID$(Pall$, i%, 1)) \ 4     'div by 4
                        G% = ASC(MID$(Pall$, i% + 1, 1)) \ 4 'div by 4
                        R% = ASC(MID$(Pall$, i% + 2, 1)) \ 4 'div by 4
                        'Byte 4 unused. Just for padding 32 bit regs
                        OUT &H3C9, R%
                        OUT &H3C9, G%
                        OUT &H3C9, B%
                NEXT i%
        END IF
END IF

'Read and Write time!!!
'Notes: Bad MS(I don't get it why they stored it backwards?)

Byte$ = SPACE$(BMP.WID)
DEF SEG = DestSeg%

Wide% = BMP.WID - 1             'Sub 1 since we start at zero
Hite% = BMP.HEI - 1
FOR y% = Hite% TO 0 STEP -1
        GET #F%, , Byte$
FOR x% = 0 TO Wide%
        c% = ASC(MID$(Byte$, x% + 1, 1))
        PSET (x%, y%), c%
NEXT x%
NEXT y%

END SUB

SUB RotateAndProject (Model() AS Point3d, AngleX, AngleY, AngleZ) STATIC

''Right handed system
''when camera components increase:
''x=goes left
''y=goes down
''z goes into the screen

'''rotation: counter-clockwise of each axis
''ei.  make yourself perpenicular to the axis
''wave your hand from the center of your body to the left.
''That's how it rotates. ;*)


'Precalculate the SIN and COS of each angle
cx! = Lcos(AngleX)
sx! = Lsin(AngleX)
cy! = Lcos(AngleY)
sy! = Lsin(AngleY)
cz! = Lcos(AngleZ)
sz! = Lsin(AngleZ)

'''After2 hours of work, I was able to weed out the constants from
'''Rotate and project N to reduce my muls to 9 instead of 12. woot!!!!

xx! = cy! * cz!
xy! = sx! * sy! * cz! - cx! * sz!
xz! = cx! * sy! * cz! + sx! * sz!

yx! = cy! * sz!
yy! = cx! * cz! + sx! * sy! * sz!
yz! = -sx! * cz! + cx! * sy! * sz!

zx! = -sy!
zy! = sx! * cy!
zz! = cx! * cy!

FOR i = 0 TO UBOUND(Model) - 1

        x! = Model(i).x
        y! = Model(i).y
        z! = Model(i).z

        RotX! = (x! * xx! + y! * xy! + z! * xz!) - camx%
        RotY! = (x! * yx! + y! * yy! + z! * yz!) - camy%
        RotZ! = (x! * zx! + y! * zy! + z! * zz!) - camz%

        Model(i).xr = RotX!
        Model(i).yr = RotY!
        Model(i).Zr = RotZ!


        'Project
        Distance% = (LENS - RotZ!)
        IF Distance% THEN
            Model(i).scrx = (LENS * RotX! / Distance%) + XCENTER
            Model(i).scry = -(LENS * RotY! / Distance%) + YCENTER
        ELSE
        END IF
NEXT i


END SUB

SUB SetVideoSeg (Segment) STATIC

DEF SEG

IF VideoAddrOff& = 0 THEN ' First time the sub is called

' We need to find the location of b$AddrC, which holds the graphics
' offset (b$OffC) and segment (b$SegC). Since b$AddrC is in the default
' segment, we can find it by setting it to a certain value, and then
' searching for that value.

SCREEN 13 ' Set b$SegC to A000 (00A0 in memory)
PSET (160, 100), 0 ' Set b$OffC to 7DA0 (not needed in the IDE)

FOR offset& = 0 TO 32764 ' Search for b$AddrC, which is
IF PEEK(offset&) = &HA0 THEN ' in the default segment and
IF PEEK(offset& + 1) = &H7D THEN ' should have a value of
IF PEEK(offset& + 2) = &H0 THEN ' A0 7D 00 A0.
IF PEEK(offset& + 3) = &HA0 THEN
VideoAddrOff& = offset& + 2 ' If we found it, record the
EXIT FOR ' offset of b$SegC and quit
END IF ' looking. (Oddly, changing
END IF ' the b$OffC doesn't seem to
END IF ' do anything, so this is why
END IF ' this sub only changes b$SegC)
NEXT

END IF

' Change b$SegC to the specified Segment

POKE VideoAddrOff&, Segment AND &HFF
POKE VideoAddrOff& + 1, (Segment AND &HFF00&) \ &H100




END SUB

SUB SortIndex (Poly() AS PolyType, Min, Max)
    'Shell sort Algorithm
    ' Set comparison offset to half the number of records.
    offset = Max \ 2

    ' Loop until offset gets to zero.
    DO WHILE offset > 0

        Limit = Max - offset

        DO

            ' Assume no switches at this offset.
            Switch = False

            ' Compare elements for the specified field and switch
            ' any that are out of order.
            FOR i = Min TO Limit - 1
                Ti = Poly(i).zcenter
                Tj = Poly(i + offset).zcenter
                        IF Ti > Tj THEN
                            SWAP Poly(i).idx, Poly(i + offset).idx
                            SWAP Poly(i).zcenter, Poly(i + offset).zcenter
                            Switch = i
                        END IF

            NEXT i

            ' Sort on next pass only to location where last switch was made.
            Limit = Switch

        LOOP WHILE Switch

        ' No switches at last offset. Try an offset half as big.
        offset = offset \ 2
    LOOP


END SUB

SUB SortPolys (Model() AS Point3d, Poly() AS PolyType)

 FOR i% = 0 TO UBOUND(Poly)' - 1
  Poly(i%).zcenter = Model(Poly(i%).p1).Zr + Model(Poly(i%).p2).Zr + Model(Poly(i%).p3).Zr
  Poly(i%).idx = i%
 NEXT i%

 SortIndex Poly(), 0, UBOUND(Poly) '- 1

END SUB

SUB Tritexture (xx1%, yy1%, xx2%, yy2%, xx3%, yy3%, uu1%, vv1%, uu2%, vv2%, uu3%, vv3%, TSEG%, TOFF%)

x1% = xx1%
y1% = yy1%
u1% = uu1%
v1% = vv1%

x2% = xx2%
y2% = yy2%
u2% = uu2%
v2% = vv2%

x3% = xx3%
y3% = yy3%
u3% = uu3%
v3% = vv3%




DEF SEG = TSEG%
TSIZ% = (PEEK(TOFF%) + PEEK(TOFF% + 1) * 256) \ 8
IF y1% > y2% THEN SWAP y1%, y2%: SWAP x1%, x2%: SWAP u1%, u2%: SWAP v1%, v2%
IF y1% > y3% THEN SWAP y1%, y3%: SWAP x1%, x3%: SWAP u1%, u3%: SWAP v1%, v3%
IF y2% > y3% THEN SWAP y2%, y3%: SWAP x2%, x3%: SWAP u2%, u3%: SWAP v2%, v3%


d1& = 0: dg1 = 0

ydiffa% = y2% - y1%
IF ydiffa% THEN
d1& = ((x2% - x1%) * 65536) \ ydiffa%
ud1& = ((u2% - u1%) * 65536) \ ydiffa%
vd1& = ((v2% - v1%) * 65536) \ ydiffa%
END IF

ydiffb% = y3% - y2%
IF ydiffb% THEN
d2& = ((x3% - x2%) * 65536) \ ydiffb%
ud2& = ((u3% - u2%) * 65536) \ ydiffb%
vd2& = ((v3% - v2%) * 65536) \ ydiffb%
END IF

ydiffc% = y3% - y1%
IF ydiffc% THEN
d3& = ((x3% - x1%) * 65536) \ ydiffc%
ud3& = ((u3% - u1%) * 65536) \ ydiffc%
vd3& = ((v3% - v1%) * 65536) \ ydiffc%
END IF

lx& = x1% * 65536
rx& = x1% * 65536

lu& = u1% * 65536: ru& = lu&
lv& = v1% * 65536: rv& = lv&

FOR y% = y1% TO y2% - 1
HTLine (lx& \ 65536), (rx& \ 65536), y%, (lu&), (ru&), (lv&), (rv&), TSIZ%, TOFF% + 4
  lx& = lx& + d1&
  rx& = rx& + d3&
  lu& = lu& + ud1&
  ru& = ru& + ud3&
  lv& = lv& + vd1&
  rv& = rv& + vd3&
NEXT

lx& = (x2% * 65536)
lu& = u2% * 65536
lv& = v2% * 65536

' HERE d1 has been added (y2%-y1%)+1 times to lx  = x2
'      d3 has been added (y2%-y1%)+1 times to rx

FOR y% = y2% TO y3%

  HTLine (lx& \ 65536), (rx& \ 65536), y%, (lu&), (ru&), (lv&), (rv&), TSIZ%, TOFF% + 4

  lx& = lx& + d2&
  rx& = rx& + d3&
  lu& = lu& + ud2&
  ru& = ru& + ud3&
  lv& = lv& + vd2&
  rv& = rv& + vd3&
NEXT y%

END SUB

